#using <mscorlib.dll>
#ifndef SUSIEEXCEPTION
#define SUSIEEXCEPTION

#include "SusieError.h"

using namespace System;

namespace HongliangSoft {
  namespace Utilities {
    public __gc class SusieException : public Exception {
    private :
      SusieError errorCode;
    private public :
      SusieException(SusieError errorCode) {
        this->errorCode = errorCode;
      }
    public :
      __property int get_ErrorCode() { return (int)errorCode; }
      __property String* get_Description() {
        switch (errorCode) {
        case SusieError::NotImplemented :
          return S"̃vOCł̓T|[gĂȂ@\łB";
        case SusieError::CancelByCallback :
          return S"R[obNɂđ삪LZ܂B";
        case SusieError::UnknownFormat :
          return S"m̃tH[}bgłB";
        case SusieError::DataBroken :
          return S"f[^Ă܂B";
        case SusieError::MemoryAllocationFailed :
          return S"̊mۂɎs܂B";
        case SusieError::MemoryError :
          return S"G[łB";
        case SusieError::FileReadError :
          return S"t@C̓ǂݍ݂Ɏs܂B";
        case SusieError::Reserved :
          return S"sȃG[łB";
        case SusieError::InternalError :
          return S"G[łB";
        default :
          return S"sȃG[łB";
        }
      }
    };
  }
}
#endif